#include "baseTsd.h"
#include "http.h"
#include <windows.h>
#include <stdio.h>
#include <TCHAR.H>
#include <wininet.h>
#include "common.h"

#pragma comment(lib, "Wininet.lib")

unsigned int EncryptionCode = 0XEF0A13BC;

LPCTSTR DefaultServerUrl =  _T("http://192.168.1.9/");
LPCTSTR DepDirectoryName = _T("dep");


#define BufferSize 16*1024



void net2path(LPCTSTR src, LPTSTR dst)
{
	int i = 0;

	while (i < MY_MAX_PATH)
	{
		if (src[i] == _T('/'))
		{
			dst[i] = _T('\\');
		}
		else
		{
			dst[i] = src[i];
		}
		if (dst[i] == _T('\0'))
		{
			break;
		}
		i ++;	
	}
}

void path2net(LPCTSTR src, LPTSTR dst)
{
	int i = 0;

	while (i < MY_MAX_PATH)
	{
		if (src[i] == _T('\\'))
		{
			dst[i] = _T('/');
		}
		else
		{
			dst[i] = src[i];
		}
		if (dst[i] == _T('\0'))
		{
			break;
		}
		i ++;	
	}
}


void net2path(LPTSTR path)
{
	int i = 0;

	while (i < MY_MAX_PATH)
	{
		if (path[i] == _T('/'))
		{
			path[i] = _T('\\');
		}	
		if (path[i] == _T('\0'))
		{
			break;
		}
		i ++;	
	}
}

void path2net(LPTSTR path)
{
	int i = 0;

	while (i < MY_MAX_PATH)
	{
		if (path[i] == _T('\\'))
		{
			path[i] = _T('/');
		}
	
		if (path[i] == _T('\0'))
		{
			break;
		}
		i ++;	
	}
}

bool getFullName(LPCTSTR shortName, LPTSTR buffer, DWORD bufferSize)
{
	int length;
	if (GetCurrentDirectory(bufferSize, buffer))
	{
		length = _tcslen(buffer);
		if (shortName[0] != _T('\\'))
		{
			_stprintf(buffer + length, _T("\\%s"), shortName);
		}
		else
		{
			_stprintf(buffer + length, _T("%s"), shortName);
		}

		return true;
	}
	return false;
}

void ansi2unicode(LPCSTR src, LPWSTR dst)
{
	int length;
	length = strlen(src);

	for (int i =0 ; i < length; i++)
	{
		_stprintf(dst  + i, _T("%c"), src[i]);
	}
}



bool getFileExtName(LPTSTR dstName, LPCTSTR srcName, LPCTSTR extName)
{
	bool result = false;
	int length = 0;
	LPTSTR ptr = _tcsrchr(srcName, _T('.'));
	if (ptr != NULL)
	{
		length = ptr - srcName;
		_sntprintf(dstName, length, _T("%s.%s"), srcName, extName);
		result = true;
	}
	return result;

}

int checkFileExt(LPCWSTR fileName)
{
	int result = FILE_EXT_UNKNOWN;
	LPWSTR ptr = wcsrchr(fileName, _T('.'));
	if (ptr != NULL)
	{
		if (_wcsicmp(ptr, L".c")== 0 || _wcsicmp(ptr, L".cpp")== 0)
		{
			result = FILE_EXT_SOURCE;
		}
		else
		{
			if (_wcsicmp(ptr, L".obj")== 0)
			{
				result = FILE_EXT_OBJECT;
			}
		}
	}
	return result;
}

int checkFileExt(LPCSTR fileName)
{
	int result = FILE_EXT_UNKNOWN;
	LPSTR ptr = strrchr(fileName, '.');
	if (ptr != NULL)
	{
		if (stricmp(ptr, ".c")== 0 || stricmp(ptr, ".cpp")== 0)
		{
			result = FILE_EXT_SOURCE;
		}
		else
		{
			if (stricmp(ptr, ".obj")== 0)
			{
				result = FILE_EXT_OBJECT;
			}
		}
	}
	return result;
}

bool doDownloadFile(HINTERNET hFile, HANDLE fileHandle,  DWORD length)
{
	DWORD bytesToRW = 0, bytesRW = 0;
	bool result = false;
	char* buffer;
	if ((buffer = (char*)malloc(BufferSize))!= NULL)
	{
		while (length > 0)
		{
			bytesToRW = __min(BufferSize, length);

			if (!InternetReadFile(hFile, buffer, bytesToRW, &bytesRW) || bytesRW == 0)
			{	
				break;
			}
			//decryption((LPBYTE)buffer, bytesRW);
			bytesToRW = bytesRW;
			if (WriteFile(fileHandle, buffer, bytesToRW, &bytesRW, NULL) && bytesRW == bytesToRW)
			{
				length -= bytesRW;
			}
			else
			{
				break;
			}
		}
		if (length == 0)
		{
			result = true;
		}
		free(buffer);
	}

	return result;
}


int downloadFileHelper(LPCTSTR url, LPCTSTR fileName)
{   
	HANDLE fileHandle = INVALID_HANDLE_VALUE;
	int result = 0;
	char lengthBuffer[32];
	DWORD length = 31, fileLength;
	HINTERNET hSession ;
	HINTERNET hFile;

	if ((fileHandle = CreateFile(fileName, GENERIC_ALL, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))!= INVALID_HANDLE_VALUE)
	{
		if ((hSession = InternetOpen(_T("Microsoft Internet Explorer"), INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, INTERNET_DEFAULT_HTTP_PORT))!= NULL)
		{
			if ((hFile = InternetOpenUrl(hSession, url, _T("Accept: */*") , 11, INTERNET_FLAG_RELOAD, NULL))!= NULL)
			{  			
				if (HttpQueryInfo(hFile, HTTP_QUERY_CONTENT_LENGTH , lengthBuffer, &length, 0))
				{
					lengthBuffer[length] = _T('\0');
					if (_stscanf((LPCTSTR)lengthBuffer, _T("%d"), &fileLength) == 1)
					{						
						if (doDownloadFile(hFile, fileHandle, fileLength))
						{
							mywPrintf(L"download %s of %d successful\n", fileName, fileLength);
							result = fileLength;
							//SetFileTime(fileHandle, NULL, NULL, &fileTime);
						}					
						else
						{
							mywPrintf(L"HttpQueryInfo failed with %d\n", url, GetLastError());
						}						
					}
				}
				InternetCloseHandle(hFile);	
			}
			else
			{
				mywPrintf(L"internetOpenUrl open %s failed with %d\n", url, GetLastError());
			}
			InternetCloseHandle(hSession);
		}
		else
		{
			mywPrintf(L"Internet open failed with %d\n", GetLastError());
		}
		CloseHandle(fileHandle);		
	}
	else
	{
		mywPrintf(L"create file %s failed of %d\n", fileName, GetLastError());
	}
    return result;
}

int downloadFile(LPCTSTR url, LPCTSTR fileName, bool preserveServerTime)
{  
	FILETIME fileTime;
	int length;
	int result = 0;
	bool bSetFileTime = true;
	TCHAR tempFileName[MY_MAX_PATH];

	if (!getFileLastWriteTime(fileName, &fileTime))
	{
		bSetFileTime = false;
	}
	_tcscpy(tempFileName, fileName);

	length = _tcslen(tempFileName);
	tempFileName[length-1] = _T('~');
	tempFileName[length]= _T('\0');

	if ((result = downloadFileHelper(url, tempFileName)) > 0)
	{
		if (!MoveFileEx(tempFileName, fileName, MOVEFILE_REPLACE_EXISTING))
		{
			result = 0;
		}
	}
	if (bSetFileTime)
	{
		setFileLastWriteTime(fileName, &fileTime);
	}
    return result;
}


bool getServerUrl(LPWSTR serverUrl)
{
	/*
	FILE* stream= NULL;
	if ((stream = _tfopen(_T("c:\\metaClientConfig.txt"), _T("r"))) != NULL)
	{
		if (_ftscanf(stream, _T("%s"), serverUrl) != 1)
		{	
			_tcscpy(serverUrl, DefaultServerUrl);
		}	
		fclose(stream);
	}
	else
	{
		_tcscpy(serverUrl, DefaultServerUrl);
	}
	*/
	_tcscpy(serverUrl, _T("http://192.168.1.201:2000/"));
	return true;
}

void trimTail(LPTSTR buffer)
{
	int length;
	length = _tcslen(buffer);
	while (length >0)
	{
		if (buffer[length-1] == _T('\n') || buffer[length-1] == _T('\r') || buffer[length-1] == _T(' '))
		{
			buffer[length-1] = _T('\0');
		}
		length--;
	}
}

//if exist, get info
bool isFileExist(LPCTSTR fileName, FILETIME* fileTime)
{
	HANDLE fileHandle;	
	BY_HANDLE_FILE_INFORMATION fileInfo;
	bool result = false;
	int err;
	memset(fileTime, 0, sizeof(FILETIME));
	if ((fileHandle = CreateFile(fileName, GENERIC_ALL, 0, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE)
	{
		if (GetFileInformationByHandle(fileHandle, &fileInfo))
		{
			// only if it is not an empty file
			if (fileInfo.nFileSizeHigh != 0 || fileInfo.nFileSizeLow != 0)
			{
				result = true;
			}
			memcpy(fileTime, &fileInfo.ftLastWriteTime, sizeof(FILETIME));
		}
		CloseHandle(fileHandle);		
	}
	else
	{
		err = GetLastError();
		if (err == ERROR_ACCESS_DENIED)
		{
			result = true;
		}
	}
	return result;
}


bool downloadFileHelper(LPCSTR projectName, LPCSTR shortFileName, LPWSTR command, bool preserveServerTime)
{
	bool result = false;
	WCHAR srcFileName[MY_MAX_PATH];
	WCHAR localFileName[MY_MAX_PATH];
	WCHAR url[HTTP_BUFFER_LENGTH];
	int length;

	FILETIME localFileTime;

	ansi2unicode(shortFileName, srcFileName);
	net2path(srcFileName);
	if (getFullName(srcFileName, localFileName, MY_MAX_PATH))
	{
		// we no longer check file time for downloading.... 
		//isFileExist(localFileName, &localFileTime);
		ZeroMemory(&localFileTime, sizeof(FILETIME));
		if (getServerUrl(url))
		{
			length = wcslen(url);
			wsprintf(url + length, _T("%s?%hs,%s,%u,%u"), command, projectName, srcFileName, localFileTime.dwLowDateTime, localFileTime.dwHighDateTime);
			if (downloadFile(url, localFileName, preserveServerTime) > 0)
			{
				result = true;
			}
			else
			{
				mywPrintf(L"donwload file %s failed\n", url);
			}
		}
	}
	return result;
}

char* packArgument(int argc, LPSTR* argv, char ch)
{
	int length = 0, offset =0;
	int i;
	bool isShortName = false;
	LPSTR ptr = NULL, pQuote, pStr;
	for (i=0; i< argc; i++)
	{
		length += strlen(argv[i]) + 1;
		pQuote = argv[i];
		do
		{
			pQuote = strchr(pQuote, '"');
			if (pQuote)
			{
				length ++;
				
				pQuote++;
			}
			else
			{
				break;
			}

			if (*pQuote == '\0')
			{
				break;
			}
		}
		while (true);
	}
	//one more for two null
	length ++;
	//two more for quotes around first argument
	if (strrchr(argv[0], '\\') != NULL)
	{		
		length +=2;
	}
	else
	{
		isShortName = true;
	}

	if ((ptr = (char*)malloc(length))!= NULL)
	{
		offset = 0;
		if (!isShortName)
		{
			sprintf(ptr, "\"%s\"", argv[0]);
		}
		else
		{
			sprintf(ptr, "%s", argv[0]);
		}
		offset = strlen(ptr);
		ptr[offset] = ' ';
		offset ++;
		for (i = 1; i <argc; i++)
		{			
			pStr = argv[i];
			while (*pStr != '\0')
			{
				if (*pStr == '"')
				{
					ptr[offset] = '\\';
					offset ++;
				}
				// debug only
				if (*pStr == '<' || *pStr == '>')
				{
					MessageBoxA(NULL, argv[i], "redirect operator", MB_OK);
				}

				// debug only
				//copy anyway
				ptr[offset] = *pStr;
				offset ++;
				pStr ++;
			}	
			ptr[offset] = ' ';
			offset++;
		}
		offset --;
		ptr[offset] = '\0';
	}
	return ptr;
}


LPTSTR packArgumentW(int argc, LPTSTR* argv)
{
	int length = 0, offset =0;
	int i;
	LPTSTR ptr = NULL;
	for (i=0; i< argc; i++)
	{
		length += _tcslen(argv[i]) + 1;
	}
	//one more for two null	
	if ((ptr = (LPTSTR)malloc(length))!= NULL)
	{
		for (i = 0; i <argc; i++)
		{
			length = _tcslen(argv[i]);
			_tcscpy(ptr + offset, argv[i]);
			offset+= length;
			ptr[offset] = _T(' ');
			offset++;
		}
		ptr[offset-1] = _T('\0');
	}
	return ptr;
}
			


int runShellA(LPSTR command, int argc, LPSTR* argv)
{
	PROCESS_INFORMATION pi;
	STARTUPINFOA si;
	LPSTR ptr;
	unsigned long result = 0;

	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	ZeroMemory(&si, sizeof(STARTUPINFO));

	si.cb = sizeof(STARTUPINFO);

	if ((ptr = packArgument(argc, argv))!= NULL)
	{
		if (CreateProcessA(command, ptr, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
		{
			WaitForSingleObject(pi.hProcess, INFINITE);
			GetExitCodeProcess(pi.hProcess, &result);
			CloseHandle(pi.hProcess);
			CloseHandle(pi.hThread);			
		}
		free(ptr);
	}
	return result;
}

void encryption(LPBYTE buffer, DWORD bufferSize)
{
/*
	int dwordCount;
	int i;
	DWORD* ptr;
	dwordCount = bufferSize / sizeof(DWORD);
	ptr = (DWORD*)buffer;
	for (i=0; i<dwordCount; i++)
	{
		*ptr ^= EncryptionCode;
		ptr ++;
	}
	for (i = 0; i< bufferSize%sizeof(DWORD); i++)
	{
		buffer[dwordCount*sizeof(DWORD) + i] ^= (BYTE)EncryptionCode;
	}
	*/
}

void decryption(LPBYTE buffer, DWORD bufferSize)
{
	//encryption(buffer, bufferSize);
}



bool getDependFileName(LPWSTR wzProjectName, LPCTSTR srcFileName, LPTSTR depFileName)
{
	LPTSTR ptr;
	bool result = false;
	int length;

	//get dep file name
	if ((ptr = _tcsrchr(srcFileName, _T('\\')))!= NULL)
	{
		//ptr starts with "\"
		if (GetCurrentDirectory(MY_MAX_PATH, depFileName))
		{
			length = wcslen(depFileName);
			_stprintf(depFileName + length, _T("\\..\\%s\\dep%s"), wzProjectName, ptr);
			if ((ptr = _tcsrchr(depFileName, _T('.'))) != NULL)
			{
				_tcscpy(ptr, _T(".dep"));
				result = true;
			}
		}
	}
	return result;
}

bool getFileLastWriteTime(LPCTSTR srcFileName, FILETIME* pftLastWrite)
{
	HANDLE handle;
	if ((handle = CreateFile(srcFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE)
	{
		GetFileTime(handle, NULL, NULL, pftLastWrite);
		CloseHandle(handle);
		return true;
	}
	else
	{
		//mywPrintf(L"getlastwritetime %s failed with %d\n", srcFileName, GetLastError());
	}
	return false;
}

bool setFileLastWriteTime(LPCTSTR srcFileName, FILETIME* pftLastWrite)
{
	HANDLE handle;
	bool result = false;
	if ((handle = CreateFile(srcFileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE)
	{
		if (SetFileTime(handle, NULL, NULL, pftLastWrite))
		{
			result = true;
		}
		CloseHandle(handle);		
	}
	else
	{
		//mywPrintf(L"getlastwritetime %s failed with %d\n", srcFileName, GetLastError());
	}
	return result;
}


//LPCWSTR WeekName[7] = {L"Sun", L"Mon", L"Tue", L"Wed", L"Thu", L"Fri", L"Sat"};
//LPCWSTR MonthName[12] = {L"Jan", L"Feb", L"Mar", L"Apr", L"May", L"Jun", L"Jul", L"Aug", L"Sep", L"Oct", L"Nov", L"Dec"};

LPCSTR WeekName[7] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
LPCSTR MonthName[12] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};


bool printFileTime(FILETIME* lpFileTime, LPSTR buffer)
{
	SYSTEMTIME st;
	if (FileTimeToSystemTime(lpFileTime, &st))
	{
		sprintf(buffer, "%s, %d %s %d %02d:%02d:%02d", WeekName[st.wDayOfWeek], st.wDay, MonthName[st.wMonth-1], st.wYear, 
			st.wHour, st.wMinute, st.wSecond);
		myPrintf("%s\n", buffer);
		return true;
	}
	return false;
}


bool createTempFileNameA(LPSTR buffer, DWORD bufferLength)
{
	DWORD length = 0;
	char tempFileName[MAX_PATH];
	length = GetTempPathA(bufferLength, buffer);
	myPrintf("temppath=%s,length=%d\n", buffer, length);
	if (length > 0 && length < bufferLength-1)
	{
		if (tmpnam(tempFileName))
		{
			sprintf(buffer+length-1, "%s", tempFileName); 
			return true;
		}
	}
	return false;
}




bool genericFindHelper(LPCWSTR dir, HandleSearchCallBack handleSearchCallBack, LPVOID userData, bool bFindFile)
{
	HANDLE handle;
	bool result = false;

	WCHAR curFileName[MY_MAX_PATH];
	WCHAR wildFileName[MY_MAX_PATH];
	
	WIN32_FIND_DATA ffd;
	_sntprintf(wildFileName, MY_MAX_PATH, _T("%s\\*.*"), dir);
	

	handle = FindFirstFile(wildFileName, &ffd);
	if (handle==INVALID_HANDLE_VALUE)
	{
		mywPrintf(_T("findfirst failed of error code =%d\n"), GetLastError());
		result = false;
	}
	else
	{
		do
		{	
			if (_tcsicmp(ffd.cFileName, _T("."))!=0 && _tcsicmp(ffd.cFileName, _T(".."))!=0)
			{
				_stprintf(curFileName, _T("%s\\%s"), dir, ffd.cFileName);
				if  (GetFileAttributes(curFileName)&FILE_ATTRIBUTE_DIRECTORY)
				{
					if (!bFindFile)
					{
						if (!handleSearchCallBack(curFileName, ffd.cFileName, userData))
						{
							result = true;
							break;
						}
						if (result = genericFindHelper(curFileName, handleSearchCallBack, userData, bFindFile))
						{
							break;
						}
					}					
				}
				else
				{		
					//shall we continue???
					if (bFindFile)
					{
						if (!handleSearchCallBack(curFileName, ffd.cFileName, userData))
						{
							result = true;
							break;
						}
					}
				}
			}
		}
		while (FindNextFile(handle, &ffd));	
		FindClose(handle);
	}	
	return result;
}

bool genericFind(LPCWSTR dir, HandleSearchCallBack handleSearchCallBack, LPVOID userData, bool bFindFile)
{
	TCHAR dirBuffer[MAX_PATH];
	int length;
	_tcscpy(dirBuffer, dir);
	length = _tcslen(dirBuffer);
	if (dirBuffer[length-1] == _T('\\'))
	{
		dirBuffer[length-1] = _T('\0');
	}
	return genericFindHelper(dirBuffer, handleSearchCallBack, userData, bFindFile);
}


bool getMyFilePath(LPTSTR pathBuffer)
{
	LPTSTR ptr;
	if (GetModuleFileName(NULL, pathBuffer, MY_MAX_PATH))
	{
		if ((ptr = _tcsrchr(pathBuffer, _T('\\')))!= NULL)
		{
			*ptr = _T('\0');
			return true;
		}
	}
	return false;
}